/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.activity.award.RewardMgr
 *  fire.pb.item.MailInfo
 *  fire.pb.item.SMailList
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  gnet.link.Onlines
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.Compensation
 *  xbean.CompensationInfo
 *  xbean.Pod
 *  xtable.Compensation
 *  xtable.Properties
 *  xtable.Usercompensation
 */
package fire.pb.compensation;

import fire.pb.activity.award.RewardMgr;
import fire.pb.compensation.CompensationConfig;
import fire.pb.compensation.CompensationManager;
import fire.pb.compensation.CompensationRole;
import fire.pb.compensation.CompensationToMail;
import fire.pb.compensation.SpecialCompensationConfig;
import fire.pb.item.MailInfo;
import fire.pb.item.SMailList;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import gnet.link.Onlines;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.Compensation;
import xbean.CompensationInfo;
import xbean.Pod;
import xtable.Properties;
import xtable.Usercompensation;

public class PCheckSendCompensationMsg
extends Procedure {
    private final long roleid;
    private final long time;

    public PCheckSendCompensationMsg(long roleid, long time) {
        this.roleid = roleid;
        this.time = time;
    }

    protected boolean process() throws Exception {
        CompensationRole compensRole;
        MailInfo mailInfo;
        List<SpecialCompensationConfig> sccs;
        boolean ret = false;
        SMailList sendMailList = new SMailList();
        long curr = System.currentTimeMillis();
        List<CompensationConfig> configs = CompensationManager.getInstance().getCompensationConfigsInTime(this.roleid, this.time);
        if (!configs.isEmpty()) {
            Compensation compensation = xtable.Compensation.get((Long)this.roleid);
            if (compensation == null) {
                compensation = Pod.newCompensation();
                xtable.Compensation.insert((Long)this.roleid, (Compensation)compensation);
            }
            for (CompensationConfig compensationConfig : configs) {
                int compensationid = compensationConfig.getCompensationid();
                CompensationInfo compensationInfo = (CompensationInfo)compensation.getCompensationmap().get(compensationid);
                if (compensationInfo == null) {
                    compensationInfo = Pod.newCompensationInfo();
                    compensation.getCompensationmap().put(compensationid, compensationInfo);
                }
                if (!compensationConfig.isInCompensationTime(curr) || CompensationManager.alreadyReceiveAward(compensation, compensationConfig)) continue;
                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
                String strTime = dateFormat.format(compensationConfig.getStartTime());
                MailInfo mailInfo2 = new MailInfo();
                mailInfo2.kind = 0;
                mailInfo2.id = compensationid;
                mailInfo2.readflag = (byte)compensationInfo.getReadflag();
                mailInfo2.time = strTime;
                mailInfo2.title = compensationConfig.getServiceMsg();
                mailInfo2.contentid = compensationConfig.getCompensationMsg();
                mailInfo2.awardid = compensationConfig.getItemid();
                this.dealAwardNumType(mailInfo2, compensationConfig.getItemid());
                mailInfo2.npcid = 0;
                sendMailList.maillist.add(mailInfo2);
                ret = true;
            }
        }
        if (!(sccs = CompensationManager.getInstance().getCompensationConfigsInTimeAndAvailable(this.time, this.roleid)).isEmpty()) {
            Compensation compensation = xtable.Compensation.get((Long)this.roleid);
            if (compensation == null) {
                compensation = Pod.newCompensation();
                xtable.Compensation.insert((Long)this.roleid, (Compensation)compensation);
            }
            for (SpecialCompensationConfig scc : sccs) {
                int serviceid = scc.getId();
                CompensationInfo compensationInfo = (CompensationInfo)compensation.getCompensationmap().get(serviceid);
                if (compensationInfo == null) {
                    compensationInfo = Pod.newCompensationInfo();
                    compensation.getCompensationmap().put(serviceid, compensationInfo);
                }
                if (!scc.isInTime(curr) || CompensationManager.alreadyReceiveAward(compensation, scc)) continue;
                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
                String strTime = dateFormat.format(scc.getStartTime());
                mailInfo = new MailInfo();
                mailInfo.kind = 0;
                mailInfo.id = serviceid;
                mailInfo.readflag = (byte)compensationInfo.getReadflag();
                mailInfo.time = strTime;
                mailInfo.title = scc.getServiceName();
                mailInfo.contentid = scc.getCompensationMsgid();
                mailInfo.awardid = scc.getAwardid();
                this.dealAwardNumType(mailInfo, scc.getAwardid());
                mailInfo.npcid = 0;
                sendMailList.maillist.add(mailInfo);
                ret = true;
            }
        }
        String useridStr = String.valueOf(Properties.selectUserid((Long)this.roleid));
        List<SpecialCompensationConfig> list = CompensationManager.getInstance().getUseridCompensationConfigsInTimeAndAvailable(this.roleid, this.time, useridStr);
        if (!list.isEmpty()) {
            Compensation compensation = Usercompensation.get((String)useridStr);
            if (compensation == null) {
                compensation = Pod.newCompensation();
                Usercompensation.insert((String)useridStr, (Compensation)compensation);
            }
            for (SpecialCompensationConfig scc : list) {
                int serviceid = scc.getId();
                CompensationInfo compensationInfo = (CompensationInfo)compensation.getCompensationmap().get(serviceid);
                if (compensationInfo == null) {
                    compensationInfo = Pod.newCompensationInfo();
                    compensation.getCompensationmap().put(serviceid, compensationInfo);
                }
                if (!scc.isInTime(curr) || CompensationManager.alreadyReceiveAward(compensation, scc)) continue;
                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
                String strTime = dateFormat.format(scc.getStartTime());
                MailInfo mailInfo3 = new MailInfo();
                mailInfo3.kind = 0;
                mailInfo3.id = serviceid;
                mailInfo3.readflag = (byte)compensationInfo.getReadflag();
                mailInfo3.time = strTime;
                mailInfo3.title = scc.getServiceName();
                mailInfo3.contentid = scc.getCompensationMsgid();
                mailInfo3.awardid = scc.getAwardid();
                this.dealAwardNumType(mailInfo3, scc.getAwardid());
                mailInfo3.npcid = 0;
                sendMailList.maillist.add(mailInfo3);
                ret = true;
            }
        }
        if ((compensRole = CompensationRole.getSingleCompensation(this.roleid, true)) != null && !compensRole.getSinglecompensations().isEmpty()) {
            for (Map.Entry<Long, Long> e : compensRole.getSinglecompensations().entrySet()) {
                long compensKey = e.getKey();
                mailInfo = CompensationToMail.SingleCompensation2Mail(compensRole, compensKey);
                if (mailInfo == null) continue;
                sendMailList.maillist.add(mailInfo);
                ret = true;
            }
        }
        if (ret) {
            Onlines.getInstance().send(Long.valueOf(this.roleid), (Protocol)sendMailList);
        }
        return ret;
    }

    public void dealAwardNumType(MailInfo mailInfo, int awardid) {
        long awardgold;
        long awardmoney;
        HashMap<String, Integer> paras = new HashMap<String, Integer>();
        Team team = TeamManager.selectTeamByRoleId((long)this.roleid);
        if (team == null) {
            paras.put("TeamNum", 1);
        } else {
            paras.put("TeamNum", team.getNormalMemberIds().size());
        }
        long awardexp = RewardMgr.getInstance().getAwardExpdistributeAllAward(this.roleid, awardid, paras, true);
        if (awardexp > 0L) {
            mailInfo.awardexp = awardexp;
        }
        if ((awardmoney = RewardMgr.getInstance().getAwardMoneydistributeAllAward(this.roleid, awardid, paras, true)) > 0L) {
            mailInfo.awardmoney = awardmoney;
        }
        if ((awardgold = RewardMgr.getInstance().getAwardGolddistributeAllAward(this.roleid, awardid, paras, true)) > 0L) {
            mailInfo.awardgold = awardgold;
        }
    }
}

